#!/bin/sh
#*******************************************************************************
# Copyright (c) 2014-2015  Hewlett-Packard Development Company, L.P. 
# All rights reserved.
#*******************************************************************************

SCSI=`lsscsi 2>/dev/null| grep disk |awk -F/ 'NF>0{print "/dev/"$NF}'`
DISKS=""
OS=``

if [[ -e "/etc/redhat-release" ]]; then
    OS=`/bin/cat /etc/redhat-release 2>/dev/null| awk '{print $1 $2}'`
elif [[ -e "/etc/SuSE-release" ]]; then
    OS=`/bin/cat /etc/SuSE-release 2>/dev/null| awk '{print $1 $2}'`
elif [[ -e "/etc/os-release" ]]; then
    OS=`/bin/cat /etc/os-release | grep "PRETTY_NAME=" | cut -d "\"" -f 2 |  awk '{print $1 $2}'`
fi

for s in $SCSI
do
iSCSIorNot="no"
sg_inq -d $s 2>/dev/null | grep -v = | grep -v : > new_file.txt
while read i
do
if [[ "$i" == *"iSCSI"* ]]; then
 iSCSIorNot="yes"
 break
fi
done < "new_file.txt"
if [ "$iSCSIorNot" == "no" ]; then
partitions=`sfdisk -l $s 2>/dev/null| grep "^\/" | awk '{print $1}'`
if [ -n "$partitions" ]; then
new_partitions=""
for p in $partitions
do
new_partitions+=$p","
done
DISKS+=$s:$new_partitions" "
else
DISKS+=$s" "
fi
fi
done
rm -f new_file.txt
PVS=` pvs 2>/dev/null |awk '{print $1}'| grep -v PV |grep -v unknown`
for d in $DISKS
do
	partitions=`echo $d | cut -d ":" -f 2`
	parent=`echo $d | cut -d ":" -f 1`
	IFS=","
	set -- $partitions
	unset IFS
	for i in $@
	do
		for v in $PVS
		do
			if [ $i == $v ];then
				PVS+=" "$parent
			fi
		done
	done
done
for v in $PVS
do
if [[ "$OS" == *"RedHat"* ]]; then
        VERSION=`/bin/cat /etc/redhat-release 2>/dev/null| awk '{print $7}'`
         if [ $(bc <<< "$VERSION < 6.0") -eq 1 ];then
                 m=`echo $v | rev |cut -d "/" -f 1 | rev`
                 WWN=`/sbin/scsi_id -g -u -s /block/$m`
        else
                WWN=`/lib/udev/scsi_id --page=0x83 --whitelisted --replace-whitespace --device=$v`
        fi
else
        WWN=`/lib/udev/scsi_id --page=0x83 --whitelisted --replace-whitespace --device=$v`
fi
if [ -n "$WWN" ];then
                                echo "physicalvolume:$v|wwn:"$WWN"|hostname="`hostname`
fi
done

for d in $DISKS
do
parent=`echo $d | cut -d ":" -f 1`
WWN=""
partitions=`echo $d | cut -d ":" -f 2`
if [[ "$OS" == *"RedHat"* ]]; then
	VERSION=`/bin/cat /etc/redhat-release 2>/dev/null| awk '{print $7}'`
	 if [ $(bc <<< "$VERSION < 6.0") -eq 1 ];then
		 m=`echo $parent | rev |cut -d "/" -f 1 | rev`
                 WWN=`/sbin/scsi_id -g -u -s /block/$m`
	else
		WWN=`/lib/udev/scsi_id --page=0x83 --whitelisted --replace-whitespace --device=$parent`
	fi
else
	WWN=`/lib/udev/scsi_id --page=0x83 --whitelisted --replace-whitespace --device=$parent`
fi

if [ $partitions != $parent ];then
if [ -n "$WWN" ];then
                                echo "device:$parent|wwn:"$WWN"|hostname="`hostname`
fi
IFS=","
set -- $partitions
unset IFS
for i in $@
do
if [ -n "$WWN" ];then
                                echo "device:$i|wwn:"$WWN"|hostname="`hostname`
fi
done
else
if [ -n "$WWN" ];then
                                echo "device:$parent|wwn:"$WWN"|hostname="`hostname`
fi
fi
done
