#!/bin/bash
#*******************************************************************************
# Copyright (c) 2014-15  Hewlett-Packard Development Company, L.P. 
# All rights reserved.
#*******************************************************************************

TOOLKIT_NAME=$1
OS=``

if [[ -e "/etc/redhat-release" ]]; then
    OS=`/bin/cat /etc/redhat-release 2>/dev/null| awk '{print $1 $2}'`
elif [[ -e "/etc/SuSE-release" ]]; then
    OS=`/bin/cat /etc/SuSE-release 2>/dev/null| awk '{print $1 $2}'`
elif [[ -e "/etc/os-release" ]]; then
    OS=`/bin/cat /etc/os-release | grep "PRETTY_NAME=" | cut -d "\"" -f 2 |  awk '{print $1 $2}'`
fi

SGCONF=""
if [[ "$OS" == *"RedHat"* ]]; then
	SGCONF=/usr/local/cmcluster/conf/modules
else
	SGCONF=/opt/cmcluster/conf/modules
fi
FILE=$SGCONF/tkit/$TOOLKIT_NAME/$TOOLKIT_NAME
if [ "$TOOLKIT_NAME" == "sitecontroller" ];then
        FILE=$SGCONF/sg/sc
fi 
if [ "$TOOLKIT_NAME" == "xdc" ];then
        FILE=$SGCONF/$TOOLKIT_NAME/$TOOLKIT_NAME
fi 
if [ "$TOOLKIT_NAME" == "enqor" ];then
        FILE=$SGCONF/sgesap/$TOOLKIT_NAME
fi
if [ "$TOOLKIT_NAME" == "3parrc" ];then
        FILE=$SGCONF/dts/$TOOLKIT_NAME
fi
if [ "$TOOLKIT_NAME" == "nfs" ];then
	listOfNFSFiles=`ls -F $SGCONF/tkit/nfs | grep -v '@' | grep -v '@' | grep -v '/' | cut -d '.' -f 2`
	latestModuleVersion=`echo "${listOfNFSFiles[*]}" | sort -nr | head -n1`
	if [ "$latestModuleVersion" -ge 3 ];then
		FILES=($SGCONF/tkit/nfs/nfs.$latestModuleVersion $SGCONF/tkit/nfs/nfsflm.*)
	fi
fi		
		
readService()
{
        FILE=$1
        cat $FILE | while read line
        do
                if [[ "$TOOLKIT_NAME" == "3parrc" ]];then
                        if [[ "$line" == *"service_name"* ]];then
                                 echo  service_name= "Rep_Monitor";
                                 echo -e "\n";
                        fi
                else
                if [[ "$line" == *"service_name"* ]];then
                         echo  service_name= $line | awk '{for (i = 2; i <= NF; i++)printf("%s ", $i);}'
                         echo -e "\n";
                     fi
                fi

                if [[ "$line" == *"service_cmd"* ]];then
                         echo service_cmd= $line | awk '{for (i = 2; i <= NF; i++)printf("%s ", $i);}'
                         echo -e "\n";

                fi
                if [[ "$line" == *"service_halt_timeout"* ]];then
                         echo service_halt_timeout= $line | awk '{for (i = 2; i <= NF; i++)printf("%s ", $i);}'
                         echo -e "\n";

                fi

                if [[ "$TOOLKIT_NAME" == *"xdc"* ]];then
                        if [[ "$line" == *"service_restart"* ]];then
                                echo service_restart= $line | awk '{for (i = 2; i <= NF; i++)printf("%s ", $i);}'
                                echo -e "\n";
                        fi
                        if [[ "$line" == *"service_fail_fast_enabled"* ]];then
                                echo service_fail_fast_enabled= $line | awk '{for (i = 2; i <= NF; i++)printf("%s ", $i);}'
                                echo -e "\n";
                        fi
                else
                        if [[ "$line" == *"service_halt_timeout"* ]];then
                                echo service_restart "none"
                                echo -e "\n";
                                echo service_fail_fast_enabled "no"
                                echo -e "\n";
                        fi

                fi
		done
}

if [ ${#FILES[@]} -eq 0 ]; then
                readService "$FILE"
                exit
else

        for (( i = 0 ; i < ${#FILES[@]} ; i++ ))
        do
                        readService "${FILES[$i]}"
        done
fi
